outlets = 5;
autowatch = 1;

var pts = 0;
var xp = new Array;
var yp = new Array;
var tot_dist = 0;

//secondary arrays for rotated points
var xp_rot = new Array;
var yp_rot = new Array;

var mysketch = new JitterObject("jit.gl.sketch", "xyview");
mysketch.blend_enable = 1;
mysketch.line_width = 4;
mysketch.depth_enable = 0;
mysketch.antialias = 1;

var gridsketch = new JitterObject("jit.gl.sketch", "grid");
gridsketch.linewidth = 2;
gridsketch.blend_enable = 1;
gridsketch.depth_enable = 0;
gridsketch.antialias = 1;

function loadbang()
//This just draws some lines and circles for the background
{
	gridsketch.glcolor(0.7, 0.7, 0.7, 1);
	gridsketch.moveto(0, 0, 0);
	var n = 1;
	for(n=1;n<=15;n++)
	{
		gridsketch.framecircle(n/5);
	}
	gridsketch.moveto(0, -1, 0);
	gridsketch.line(0, 2, 0);
	gridsketch.moveto(-1, -1, 0);
	gridsketch.line(2, 2, 0);
	gridsketch.moveto(-1, 0, 0);
	gridsketch.line(2, 0, 0);
	gridsketch.moveto(-1, 1, 0);
	gridsketch.line(2, -2, 0);
}

function bang()
//This just draws the outline from the original data set
{
	var n = 0;
	mysketch.reset();
	mysketch.glcolor(0, 0, 0, 1);
	
	for(n=0;n<xp.length-1;n++)
	{
		mysketch.moveto(xp[n], yp[n], 0);
		mysketch.lineto(xp[n+1], yp[n+1], 0);
	}
}

function graph_rot()
//identical to bang() but with the rotated data
{
	var n = 0;
	mysketch.reset();
	mysketch.glcolor(0, 0, 0, 1);
	
	for(n=0;n<xp.length-1;n++)
	{
		mysketch.moveto(xp_rot[n], yp_rot[n], 0);
		mysketch.lineto(xp_rot[n+1], yp_rot[n+1], 0);
	}
}

function mousein(args)
//adds each new point into the x, y arrays
{
	var blah = arguments;
	xp[pts] = blah[0];
	yp[pts++] = blah[1];
	bang();
}

function rot(theta)
//calculates the position of every point rotated theta radians around zero from its initial position
{
	var n = 0;
	var this_theta = 0;
	var new_theta = 0;
	var this_r = 0;
	
	for(n=0;n<xp.length;n++)
	{
			this_theta = Math.atan2(xp[n], yp[n]);
			this_r = Math.sqrt(xp[n]*xp[n] + yp[n]*yp[n]);
			
			new_theta = this_theta + theta;
			xp_rot[n] = this_r*Math.cos(new_theta);
			yp_rot[n] = this_r*Math.sin(new_theta);
	}
	dump_rot();
	graph_rot();
}

function length()
{
	tot_dist = 0;
	var n = 0;
	for(n=0;n<xp.length-1;n++)
	{
		tot_dist+=distance(xp[n], yp[n], xp[n+1], yp[n+1]);
		outlet(3, "bang");
	}
	outlet(2, xp.length);
	
}
function dump()
{
	var n = 1;
	var step_size = 0.005;
	length();	
	
	//position marker to step linearly from 0 to 1
	var wave_pos = 0;
	//position marker to keep track of current position along graph
	var track_pos = 0;

	while(wave_pos<1.0)
	{
		while(wave_pos>=track_pos)
		//find the next point along the curve *after* the current position
		{
			track_pos += distance(xp[n], yp[n], xp[n+1], yp[n+1])/tot_dist;
			outlet(1, "bang");
			n++;
		}
		
		//interpolation - the drawing cannot have discontinuity, so neither should the resulting wavetables
		var seg_dist = distance(xp[n], yp[n], xp[n-1], yp[n-1])/tot_dist;
		var dist2 = track_pos - wave_pos;
		var dist1 = seg_dist - dist2;
		var x_res = (xp[n-1]*dist2 + xp[n]*dist1)/seg_dist;
		var y_res = (yp[n-1]*dist2 + yp[n]*dist1)/seg_dist;
		outlet(0, x_res, y_res);
		
		outlet(4, wave_pos/step_size);
		wave_pos += step_size;
	}
}
function dump_rot()
//same as dump() but for rotated data
{
	var n = 1;
	var step_size = 0.005;
	length();	
	
	//position marker to step linearly from 0 to 1
	var wave_pos = 0;
	//position marker to keep track of current position along graph
	var track_pos = 0;

	while(wave_pos<1.0)
	{
		while(wave_pos>=track_pos)
		{
			track_pos += distance(xp_rot[n], yp_rot[n], xp_rot[n+1], yp_rot[n+1])/tot_dist;
			outlet(1, "bang");
			n++;
		}
		//outlet(0, xp_rot[n-1], yp_rot[n-1]);
		//interpolation
		var seg_dist = distance(xp_rot[n], yp_rot[n], xp_rot[n-1], yp_rot[n-1])/tot_dist;
		var dist2 = track_pos - wave_pos;
		var dist1 = seg_dist - dist2;
		var x_res = (xp_rot[n-1]*dist2 + xp_rot[n]*dist1)/seg_dist;
		var y_res = (yp_rot[n-1]*dist2 + yp_rot[n]*dist1)/seg_dist;
		outlet(0, x_res, y_res);
		
		outlet(4, wave_pos/step_size);
		
		wave_pos += step_size;
	}
}

function clear()
{
	pts = 0;
	xp.length = 0;
	yp.length = 0;
	mysketch.reset();
}

function distance(x1, y1, x2, y2)
{
	var x_dist = x2-x1;
	var y_dist = y2-y1;
	return(Math.sqrt(x_dist*x_dist + y_dist*y_dist));
}